﻿Imports System.Net
Imports System.IO
Imports EinsLiveCrawl.Bn.Classes
Imports JDP
Imports System.Xml.Serialization

Module myProgram
    Public version As String = "v0.9.8"
    Public name As String = "einslivecomedydownloader"
    Public longname As String = "SciLor's 1live.de Comedy Searcher/Downloader"
End Module

Public Class frmCrawl
    Public Class StartEndCut
        Public StartCut As String
        Public StartAppend As String
        Public EndCut As String
        Public EndAppend As String
    End Class

    Public Class SimpleCut
        Public Cut As String
    End Class

    Public Class AllCut
        Public linkCut() As StartEndCut
        Public titleCut As StartEndCut
        Public mp3Cut() As StartEndCut
        Public mp3CutSave() As SimpleCut
        Public mp3TitleCut() As StartEndCut
    End Class

    Private Structure DoCutReturn
        Dim CuttedString As String
        Dim EndPosition As Integer
    End Structure

    Public Structure downloadStructure
        Dim DownloadURL As String
        Dim FileName As String
        Dim Directory As String
    End Structure

    Dim CutData As AllCut
    Dim AppDir As String
    Dim SQLPath As String
    Dim linkList As ArrayList
    Dim downloadList As ArrayList
    Dim CurrentCrawlRound As Byte
    Dim MaxCrawlRound As Byte = 10
    Dim CurrentCrawlElements As Integer
    Dim MaxCrawlElements As Integer
    Dim CrawlState As String
    Dim LogString As String = ""
    Dim IsExit As Boolean = False
    Private WithEvents Downloader As New FileDownloader

    Private Sub frmCrawl_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        IsExit = True
        Application.Exit()
    End Sub

    Private Sub frmCrawl_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = myProgram.longname & " " & myProgram.version

        AppDir = Application.StartupPath & "\"
        SQLPath = AppDir & "CrawlDB.mdb"

        If Not File.Exists(SQLPath) Then
            File.Copy(SQLPath & ".base", SQLPath, True)
        End If

        Call SetUpCutData()
        Call SetUpCheckBox()
    End Sub

    Private Sub AddLog(ByVal Text As String)
        LogString &= vbNewLine & Text
        txtLog.Text = LogString
        txtLog.SelectionStart = txtLog.TextLength
        txtLog.ScrollToCaret()
        Application.DoEvents()
    End Sub

    Private Sub SetUpCheckBox()
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "SELECT DISTINCT(Directory) FROM Files WHERE Downloaded = 'no' ORDER BY Directory "

        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        chkDownload.Items.Clear()
        chkDownload.Items.Add("All", True)
        While SQLReader.Read
            chkDownload.Items.Add(SQLReader.Item("Directory"), False)
        End While

        SQLReader.Close()
        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()

    End Sub

    Public Sub XMLSerialize(ByVal Obj As Object, ByVal FileName As String)
        Dim XML As New XmlSerializer(Obj.GetType())
        Dim FS As New FileStream(FileName, FileMode.Create)
        XML.Serialize(FS, Obj)
        FS.Flush()
        FS.Close()
    End Sub
    Public Function XMLDeserialize(ByVal typ As Type, ByVal FileName As String)
        Dim XML As New XmlSerializer(typ)
        Dim FS As New FileStream(FileName, FileMode.Open)
        Dim obj As Object = XML.Deserialize(FS)
        FS.Close()
        Return obj
    End Function

    Private Sub SetUpCutData()


        Return

        CutData = New AllCut()
        With CutData
            .linkCut = New StartEndCut(2) {}
            .mp3Cut = New StartEndCut(2) {}
            .mp3CutSave = New SimpleCut(2) {}
            .mp3TitleCut = New StartEndCut(2) {}

            .linkCut(0) = New StartEndCut()
            With .linkCut(0)
                .StartCut = "href=""http://www.einslive.de/comedy/"
                .StartAppend = "http://www.einslive.de/comedy/"
                .EndCut = """"
                .EndAppend = ""
            End With
            .linkCut(1) = New StartEndCut()
            With .linkCut(1)
                .StartCut = "href=""/comedy/"
                .StartAppend = "http://www.einslive.de/comedy/"
                .EndCut = """"
                .EndAppend = ""
            End With

            .titleCut = New StartEndCut()
            With .titleCut
                .StartCut = "<title>"
                .EndCut = "</title>"
            End With

            .mp3Cut(0) = New StartEndCut()
            With .mp3Cut(0)
                .StartCut = "dslSrc=%2fcomedy%2f"
                .StartAppend = "http://www.einslive.de%2fcomedy%2f"
                .EndCut = "&amp;"
                .EndAppend = ""
                CutData.mp3CutSave(0) = New SimpleCut()
                CutData.mp3CutSave(0).Cut = ">"
            End With
            .mp3TitleCut(0) = New StartEndCut()
            With .mp3TitleCut(0)
                .StartCut = "%2fcomedy%2f"
                .StartAppend = ""
                .EndCut = "%2f"
                .EndAppend = ""
            End With
            With .mp3Cut(1)
                .StartCut = "dslSrc=http://www.einslive.de%2fcomedy%2fcomedy%2f"
                .StartAppend = "http://www.einslive.de%2fcomedy%2f"
                .EndCut = "&amp;"
                .EndAppend = ""
                CutData.mp3CutSave(1) = New SimpleCut()
                CutData.mp3CutSave(1).Cut = ">"
            End With
            .mp3TitleCut(1) = New StartEndCut()
            With .mp3TitleCut(0)
                .StartCut = "%2fcomedy%2f"
                .StartAppend = ""
                .EndCut = "%2f"
                .EndAppend = ""
            End With
          

            '.mp3Cut(0) = New StartEndCut()
            'With .mp3Cut(0)
            '    .StartCut = "dslSrc=/comedy/"
            '    .StartAppend = "rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/comedy/"
            '    .EndCut = ".mp3"
            '    .EndAppend = ""
            '    CutData.mp3CutSave(0) = New SimpleCut()
            '    CutData.mp3CutSave(0).Cut = ">"
            'End With
            '.mp3TitleCut(0) = New StartEndCut()
            'With .mp3TitleCut(0)
            '    .StartCut = "/comedy/"
            '    .StartAppend = ""
            '    .EndCut = "/"
            '    .EndAppend = ""
            'End With
            '.mp3Cut(1) = New StartEndCut()
            'With .mp3Cut(1)
            '    .StartCut = "dslSrc=rtmp://gffstream.fcod.llnwd.net/a792/e2/mediendb/1live/comedy/"
            '    .StartAppend = "rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/comedy/"
            '    .EndCut = ".mp3"
            '    .EndAppend = ""
            '    CutData.mp3CutSave(1) = New SimpleCut()
            '    CutData.mp3CutSave(1).Cut = ">"
            'End With
            '.mp3TitleCut(1) = New StartEndCut()
            'With .mp3TitleCut(1)
            '    .StartCut = "/comedy/"
            '    .StartAppend = ""
            '    .EndCut = "/"
            '    .EndAppend = ""
            'End With
        End With
        XMLSerialize(CutData, "cutdata.xml")
    End Sub

    Private Sub StartDumping()
        FixOldRtmpStreams()
        Call AddLog("Start website crawling")
        For I = 1 To MaxCrawlRound
            Call GetLinkList()
            CurrentCrawlRound = I
            CurrentCrawlElements = 0
            MaxCrawlElements = linkList.Count
            Call DrawCrawlState()
            Call AddLog("Starting website crawl round " & I & " of " & MaxCrawlRound)
            Application.DoEvents()
            For Each Element In linkList
                Dim tempDownload As String
                Dim tempCut As DoCutReturn
                Dim StartNum As Integer
                Dim MaxNum As Integer

                CurrentCrawlElements += 1
                CrawlState = "Get Website"
                Call AddLog("Start to analyse """ & Element & """")
                Call DrawCrawlState()
                Application.DoEvents()

                tempDownload = webDownload(Element)
                tempDownload = tempDownload.Replace(".MP3", "<FIX>.mp3")

                CrawlState = "1/2 - GetLinks"
                Call DrawCrawlState()
                Application.DoEvents()
                For ArrayCounter = 0 To CutData.linkCut.Length - 1
                    StartNum = 1
                    MaxNum = 1
                    tempCut.CuttedString = ""
                    Do Until tempCut.CuttedString = "DoCutError" Or StartNum < MaxNum
                        If Not tempCut.CuttedString = "" And Not tempCut.CuttedString.Contains("?versenden=1") And Not tempCut.CuttedString.EndsWith("?rdf=1") Then Call InsertURL(tempCut.CuttedString)
                        MaxNum = StartNum
                        tempCut = DoCut(tempDownload, CutData.linkCut(ArrayCounter), StartNum)
                        StartNum = tempCut.EndPosition
                    Loop
                Next

                CrawlState = "2/2 - GetDownloads"
                Call DrawCrawlState()
                Application.DoEvents()

                For ArrayCounter = 0 To CutData.mp3Cut.Length - 1
                    StartNum = 1
                    MaxNum = 1
                    tempCut.CuttedString = ""
                    Do Until tempCut.CuttedString = "DoCutError" Or StartNum < MaxNum
                        If Not tempCut.CuttedString = "" Then
                            Call InsertDownload(tempCut.CuttedString, Element, DoCut(tempCut.CuttedString, CutData.mp3TitleCut(ArrayCounter)).CuttedString)
                        End If
                        MaxNum = StartNum
                        tempCut = DoCut(tempDownload, CutData.mp3Cut(ArrayCounter), StartNum)
                        StartNum = tempCut.EndPosition
                    Loop
                Next
                Call CheckLink(Element)
                CrawlState = ""
                Call DrawCrawlState()
                Application.DoEvents()
                Call AddLog("Analysing finished" & vbNewLine)
                If IsExit = True Then Exit For
            Next
            Call AddLog("Crawling round finished" & vbNewLine)
            If IsExit = True Then Exit For
        Next
        Call AddLog("Website crawling finished")
    End Sub


    Public Function webDownload(ByVal sURL As String) As String
        Try
Retry:
            ' WebRequest
            Dim oRequest As WebRequest = WebRequest.Create(sURL)

            ' GET-Methode (wir wollen etwas abholen :-)
            oRequest.Method = "GET"
            ' Antwort auf unsere Anfrage abholen
            Dim oResponse As WebResponse = oRequest.GetResponse()

            ' Datenstrom auslesen
            Dim oStream As Stream = oResponse.GetResponseStream()
            Dim oStreamReader As New StreamReader(oStream, System.Text.Encoding.Default)

            webDownload = oStreamReader.ReadToEnd()
            oStream.Close()
            oStreamReader.Close()

            ' Beenden
            oResponse.Close()
            Call AddLog("Website download successful")
        Catch Ex As Exception
            Call AddLog("XXX - Website download problem(" & Ex.Message & ") """ & sURL & """" & vbNewLine)
            Return "Error"
            GoTo Retry
        End Try
    End Function

    Public Function rtmpDownload(ByVal sURL As String, ByVal strFile As String, ByVal strFolder As String) As Boolean
        Dim myStringWebResource As String = Nothing
        ' Create a new WebClient instance.
        Dim myWebClient As New WebClient()
        Dim myHeaders As New WebHeaderCollection
        pgbDownload.Maximum = 2
        pgbDownload.Value = 0
        Application.DoEvents()
        Try

            Call AddLog("Try to download file """ & strFolder & strFile & """")

            System.IO.Directory.CreateDirectory(strFolder)
            Dim process As New Process()
            Dim FileName As String = "rtmpdump.exe"
            Dim Arguments As String = "-r" & " " & """" & sURL & """" & " " & "-o" & " " & """" & strFolder & strFile & ".flv" & """"
            process.StartInfo.UseShellExecute = False
            process.StartInfo.RedirectStandardOutput = True
            process.StartInfo.RedirectStandardError = True
            process.StartInfo.CreateNoWindow = True
            process.StartInfo.FileName = FileName
            process.StartInfo.Arguments = Arguments
            process.StartInfo.WorkingDirectory = AppDir
            process.Start()
            Dim output As String = process.StandardOutput.ReadToEnd()

            If Not File.Exists(strFolder & strFile & ".flv") Then
                Call AddLog("Problem with creating the flv" & vbNewLine)
            End If

            pgbDownload.Value = 1
            Application.DoEvents()
            Dim inputPath As String = strFolder & strFile & ".flv"
            Dim outputDirectory As String = strFolder
            Using flvFile As New FLVFile(Path.GetFullPath(inputPath))
                If outputDirectory IsNot Nothing Then
                    flvFile.OutputDirectory = Path.GetFullPath(outputDirectory)
                End If
                flvFile.ExtractStreams(True, True, False, Nothing)
                If flvFile.Warnings.Length <> 0 Then
                    For Each warning As String In flvFile.Warnings
                        Call AddLog("Warning: " & warning)
                    Next
                End If
            End Using
            pgbDownload.Value = 2
            Application.DoEvents()

            If File.Exists(strFolder & strFile & ".mp3") Or File.Exists(strFolder & strFile & ".mp4") Then
                File.Delete(strFolder & strFile & ".flv")
                Call AddLog("File download successful" & vbNewLine)
                Return True
            Else
                Call AddLog("Problem with creating the mp3" & vbNewLine)
            End If
        Catch Ex As Exception
            Call AddLog("XXX - File download problem(" & Ex.Message & ") """ & sURL & """(" & strFolder & strFile & ")" & vbNewLine)
            pgbDownload.Value = 0
        End Try

        Return False
    End Function

    Private Function DownloadItem(ByVal sURL As String, ByVal strFile As String, ByVal strFolder As String)

        Dim myStringWebResource As String = Nothing
        ' Create a new WebClient instance.
        Dim myWebClient As New WebClient()
        Dim myHeaders As New WebHeaderCollection
        pgbDownload.Value = 0
        Try

            Call AddLog("Try to download file """ & strFolder & strFile & """")

            System.IO.Directory.CreateDirectory(strFolder)

            Dim myWebRequest As WebRequest
            myWebRequest = WebRequest.Create(sURL)

            Dim tempStream As Stream = myWebRequest.GetResponse.GetResponseStream
            Dim DataRead As Integer
            Dim LoadedData As Integer = 0
            Dim tempBuffer(1023) As Byte
            Dim tempFile As New IO.FileStream(strFolder & strFile, IO.FileMode.Create)

            pgbDownload.Value = 0
            pgbDownload.Maximum = myWebRequest.GetResponse.ContentLength
            Do Until myWebRequest.GetResponse.ContentLength = LoadedData
                DataRead = tempStream.Read(tempBuffer, 0, tempBuffer.Length)
                tempFile.Write(tempBuffer, 0, DataRead)
                LoadedData += DataRead
                pgbDownload.Value = LoadedData
                Application.DoEvents()
            Loop
            tempStream.Close()
            tempFile.Close()


            ' Concatenate the domain with the Web resource filename. Because DownloadFile 
            'requires a fully qualified resource name, concatenate the domain with the Web resource file name.

            'Console.WriteLine("Downloading File ""{0}"" from ""{1}"" ......." + ControlChars.Cr + ControlChars.Cr, strFile, myStringWebResource)
            ' The DownloadFile() method downloads the Web resource and saves it into the current file-system folder.

            'myStringWebResource = sURL
            'System.IO.Directory.CreateDirectory(strFolder)
            'myWebClient.DownloadFile(myStringWebResource, strFolder & strFile)
            'myHeaders = myWebClient.ResponseHeaders

            'For i = 0 To myHeaders.Count - 1
            '    If myHeaders.GetKey(i) = "Content-Disposition" Then
            '        txtDownload.Text = txtDownload.Text & "Successfully Downloaded file ""{0}"" from ""{1}"""
            '        txtDownload.Text += vbNewLine
            '        Exit For
            '    ElseIf myHeaders.Count - 1 = i Then
            '        File.Delete(strFolder & strFile & ".pdf")
            '    End If
            'Next
            Call AddLog("File download successful" & vbNewLine)
            pgbDownload.Value = 0
            Return True
        Catch Ex As Exception
            Call AddLog("XXX - File download problem(" & Ex.Message & ") """ & sURL & """(" & strFolder & strFile & ")" & vbNewLine)
            pgbDownload.Value = 0
            Return False
        End Try

    End Function

    Private Function Ticks2String(ByVal Ticks As Int64) As String
        Dim Ticks2Minutes As Int64 = Int(Ticks / (10000 * 1000 * 60))
        Dim Ticks2Seconds As Int64 = Int(Ticks / (10000 * 1000)) - (Ticks2Minutes * 60)

        Ticks2String = Format(Ticks2Minutes, "00") & ":" & Format(Ticks2Seconds, "00")
        Return Ticks2String
    End Function

    Private Sub DownloadAllNewFiles()
        Call GetDownloadList()
        Dim TempCount As Integer = 0
        Dim MaxCount As Integer = downloadList.Count
        Dim StartTime As Int64 = Now.Ticks
        Dim tempTime As Int64

        Call AddLog("Start downloading files")
        pgbAll.Value = 0
        pgbAll.Maximum = downloadList.Count
        For Each Element As downloadStructure In downloadList
            TempCount += 1
            tempTime = Math.Max(Now.Ticks - StartTime, 1)
            tempTime = (tempTime / (TempCount)) * (MaxCount - TempCount)

            lblStatus.Text = "Downloading...  Time Left: " & Ticks2String(tempTime) & vbNewLine & "File: " & TempCount & "\" & MaxCount & vbNewLine & "Location: " & Element.Directory & "\" & Element.FileName
            Application.DoEvents()
            If Element.DownloadURL.StartsWith("rtmp") Then
                If rtmpDownload( _
                                    Element.DownloadURL, _
                                    Element.FileName, _
                                    AppDir & "Downloaded\" & Element.Directory & "\" _
                                    ) _
                        = True Then
                    Call SetDownloaded(Element.DownloadURL)
                End If
            Else
                If DownloadItem( _
                                    Element.DownloadURL, _
                                    Element.FileName, _
                                    AppDir & "Downloaded\" & Element.Directory & "\" _
                                    ) _
                        = True Then
                    Call SetDownloaded(Element.DownloadURL)
                End If
            End If
            pgbAll.Value = TempCount
            If IsExit = True Then Exit For
        Next
        pgbAll.Value = 0
        Call AddLog("File download finished")

    End Sub

    Private Function DoCut(ByVal sTemp As String, ByVal CutText As StartEndCut, Optional ByVal StartNum As Integer = 1) As DoCutReturn
        Dim curPos(1) As Integer
        Dim ReturnData As DoCutReturn
        'On Error Resume Next
        Try
            curPos(0) = InStr(StartNum, sTemp, CutText.StartCut) + Len(CutText.StartCut) - 1
            curPos(1) = InStr(curPos(0) + 1, sTemp, CutText.EndCut) - 1

            If curPos(0) = Len(CutText.StartCut) - 1 Then Throw New Exception("Empty.") 'InStr = -1 if emtpy

            ReturnData.EndPosition = curPos(1) + Len(CutText.EndCut)
            ReturnData.CuttedString = CutText.StartAppend & sTemp.Substring(curPos(0), curPos(1) - curPos(0)) & CutText.EndAppend
        Catch
            ReturnData.CuttedString = "DoCutError"
        End Try
        ReturnData.CuttedString = Replace(ReturnData.CuttedString, "<FIX>.mp3", ".MP3")
        Return ReturnData
    End Function

    Private Sub FixDirectorys()
        Dim Find() As String = Split(LoadFile("whatReplace.txt"), vbNewLine)
        Dim Replace() As String = Split(LoadFile("replaceLinkUrl.txt"), vbNewLine)
        Dim ReplaceTemp() As String
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim I As Integer = 0
        Dim FindLength As Integer = Find.Length
        Dim ReplaceLength As Integer = Replace.Length
        Dim FindString As String
        If FindLength > 0 Then
            dbConn.Open()
            SQL.Connection = dbConn

            FindString = "Directory = @Directory" & I
            For I = 1 To FindLength - 1
                FindString &= " OR Directory = @Directory" & I
            Next

            SQL.CommandText = "SELECT DateTime FROM Files WHERE " & FindString
            SQL.Parameters.Clear()
            For I = 0 To FindLength - 1
                SQL.Parameters.AddWithValue("@Directory" & I, Find(I))
            Next

            Dim tempReader As OleDb.OleDbDataReader = SQL.ExecuteReader()
            If tempReader.HasRows = True Then
                tempReader.Close()
                SQL.CommandText = "UPDATE Files SET Directory = @NewDirectory WHERE LinkURL LIKE @LinkURL AND " & "(" & FindString & ")"
                For I = 0 To ReplaceLength - 1
                    SQL.Parameters.Clear()
                    ReplaceTemp = Split(Replace(I), ";")
                    SQL.Parameters.AddWithValue("@NewDirectory", ReplaceTemp(1))
                    SQL.Parameters.AddWithValue("@LinkURL", "%" & ReplaceTemp(0) & "%")
                    For J = 0 To FindLength - 1
                        SQL.Parameters.AddWithValue("@Directory" & J, Find(J))
                    Next
                    SQL.ExecuteNonQuery()
                Next
            Else
                tempReader.Close()
            End If

            'I = 0
            ''Not in file, but may fixable
            'FindString = "LinkURL LIKE @LinkURL" & I
            'For I = 1 To FindLength - 1
            '    FindString &= " OR LinkURL LIKE @LinkURL" & I
            'Next

            'SQL.CommandText = "SELECT LinkURL FROM Files WHERE " & FindString
            'SQL.Parameters.Clear()
            'For I = 0 To FindLength - 1
            '    SQL.Parameters.AddWithValue("@LinkURL" & I, "%/" & Find(I) & "/%/%")
            'Next

            'tempReader = SQL.ExecuteReader()
            'If tempReader.HasRows = True Then

            'End If

            SQL.Dispose()
            dbConn.Close()
            dbConn.Dispose()
        End If
    End Sub

    Public Function GetConnection() As OleDb.OleDbConnection
        Return New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;" & "Data Source=" & SQLPath)
    End Function

    Private Function GetDateTime(Optional ByVal TimeFix As Integer = 0)
        Dim MyDateTime As Date = DateTime.Now.AddDays(-TimeFix)
        Return MyDateTime.Year & Format(MyDateTime.Month, "00") & Format(MyDateTime.Day, "00") & " " & Format(MyDateTime.Hour, "00") & Format(MyDateTime.Minute, "00")
    End Function

    Private Function UrlDecode(ByVal ConvertString As String)
        Return System.Web.HttpUtility.UrlDecode(ConvertString)
    End Function

    Public Sub InsertURL(ByVal URL As String)
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime()
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "SELECT URL FROM Links WHERE URL = @URL"
        SQL.Parameters.AddWithValue("@URL", UrlDecode(URL))

        If SQL.ExecuteScalar = "" Then
            SQL.CommandText = "INSERT INTO Links (URL) VALUES (@URL)"

            SQL.Parameters.Clear()
            SQL.Parameters.AddWithValue("@URL", UrlDecode(URL))
            'SQL.Parameters.AddWithValue("@Title", UrlDecode(Title))
            'SQL.Parameters.AddWithValue("@DateTime", DateString)

            SQL.ExecuteNonQuery()
            Call AddLog("Added new URL """ & URL & """")
        Else
            SQL.CommandText = "UPDATE Links SET [DateTime] = @DateTime WHERE URL = @URL"
            SQL.Parameters.Clear()
            SQL.Parameters.AddWithValue("@URL", UrlDecode(URL))
            'SQL.Parameters.AddWithValue("@Title", UrlDecode(Title))
            SQL.Parameters.AddWithValue("@DateTime", DateString)
            SQL.ExecuteNonQuery()
        End If

        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Public Sub FixOldRtmpStreams()
        'rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/comedy/
        'rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/magazin/
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand

        dbConn.Open()
        SQL.Connection = dbConn

        Dim ComRTMP As String = "rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/comedy/"
        Dim MagRTMP As String = "rtmp://gffstream.fcod.llnwd.net:1935/a792/e2/mp3:mediendb/1live/magazin/"

        SQL.CommandText = "SELECT DownloadURL FROM Files WHERE DownloadURL LIKE @DownloadURL1 OR DownloadURL LIKE @DownloadURL2"
        SQL.Parameters.AddWithValue("@DownloadURL1", ComRTMP & "%")
        SQL.Parameters.AddWithValue("@DownloadURL2", MagRTMP & "%")

        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        While SQLReader.Read
            Dim URL As String = SQLReader.Item("DownloadURL")
            Dim FixedURL As String = URL
            FixedURL = FixedURL.Replace(ComRTMP, "http://wdr.vo.llnwd.net/e1/mediendb/1live/comedy/")
            FixedURL = FixedURL.Replace(MagRTMP, "http://wdr.vo.llnwd.net/e1/mediendb/1live/magazin/")
            FixedURL = FixedURL & ".mp3"
            FixedURL = FixedURL.Replace("<FIX>", "")


            Dim SQLCheck As New OleDb.OleDbCommand
            SQLCheck.Connection = dbConn
            SQLCheck.CommandText = "SELECT DownloadURL FROM Files WHERE DownloadURL = @DownloadURL"
            SQLCheck.Parameters.AddWithValue("@DownloadURL", FixedURL)
            If SQLCheck.ExecuteScalar = "" Then
                Dim SQLFix As New OleDb.OleDbCommand
                SQLFix.Connection = dbConn
                SQLFix.CommandText = "UPDATE Files SET [DownloadURL] = @DownloadURLNew WHERE DownloadURL = @DownloadURL"
                SQLFix.Parameters.AddWithValue("@DownloadURLNew", FixedURL)
                SQLFix.Parameters.AddWithValue("@DownloadURL", URL)
                SQLFix.ExecuteNonQuery()
                SQLFix.Dispose()
            Else
                Dim SQLFix As New OleDb.OleDbCommand
                SQLFix.Connection = dbConn
                SQLFix.CommandText = "DELETE FROM Files WHERE DownloadURL = @DownloadURL"
                SQLFix.Parameters.AddWithValue("@DownloadURL", URL)
                SQLFix.ExecuteNonQuery()
                SQLFix.Dispose()
            End If
            SQLCheck.Dispose()
        End While

        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()

    End Sub

    Public Function InsertDownload(ByVal DownloadURL As String, ByVal LinkURL As String, ByVal Directory As String)
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime()
        DownloadURL = UrlDecode(DownloadURL)
        Dim FileName As String = DownloadURL.Substring(DownloadURL.LastIndexOf("/") + Len("/"))
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "SELECT DownloadURL FROM Files WHERE DownloadURL = @DownloadURL"
        SQL.Parameters.AddWithValue("@DownloadURL", UrlDecode(DownloadURL))

        If SQL.ExecuteScalar = "" Then
            SQL.CommandText = "INSERT INTO Files (DownloadURL, LinkURL, FileName, Directory, [DateTime]) VALUES (@DownloadURL, @LinkURL, @FileName, @Directory, @DateTime)"

            SQL.Parameters.Clear()

            SQL.Parameters.AddWithValue("@DownloadURL", UrlDecode(DownloadURL))
            SQL.Parameters.AddWithValue("@LinkURL", UrlDecode(LinkURL))
            SQL.Parameters.AddWithValue("@FileName", UrlDecode(FileName))
            SQL.Parameters.AddWithValue("@Directory", UrlDecode(Directory))
            SQL.Parameters.AddWithValue("@DateTime", DateString)

            SQL.ExecuteNonQuery()

            SQL.Dispose()
            dbConn.Close()
            dbConn.Dispose()
            Call AddLog("Added new file """ & DownloadURL & """")
            Return True
        Else
            SQL.CommandText = "UPDATE Files SET [DateTime] = @DateTime WHERE DownloadURL = @DownloadURL"
            SQL.Parameters.Clear()
            SQL.Parameters.AddWithValue("@DownloadURL", UrlDecode(DownloadURL))
            SQL.Parameters.AddWithValue("@DateTime", DateString)

            SQL.ExecuteNonQuery()

            SQL.Dispose()
            dbConn.Close()
            dbConn.Dispose()
            Return False
        End If
    End Function

    Private Sub GetLinkList()
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime(0)
        linkList = New ArrayList
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "SELECT URL FROM Links WHERE Checked = 'no'"

        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        While SQLReader.Read
            Dim url As String = SQLReader.Item("URL")

            If Not url.Contains("?versenden=1") Then
                linkList.Add(url)
            End If
        End While

        'linkList = New ArrayList
        'linkList.Add("http://www.einslive.de/comedy/o_ton_charts/")

        SQLReader.Close()
        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Private Sub GetDownloadList()
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime(0)
        Dim TempDownloadList As downloadStructure
        Dim tempString As String = ""
        downloadList = New ArrayList
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "SELECT * FROM Files WHERE Downloaded = 'no'"

        If chkDownload.CheckedIndices.Contains(0) = False Then
            Dim I As Integer = 0
            SQL.CommandText &= " AND ("
            For Each ID In chkDownload.CheckedIndices
                'tempString &= chkDownload.Items.Item(I)
                tempString &= "Directory = @DirectoryCHK" & ID & " OR "
            Next
            SQL.CommandText &= tempString.Substring(0, tempString.Length - Len(" OR ")) & ")"
            For Each ID In chkDownload.CheckedIndices
                SQL.Parameters.AddWithValue("@DirectoryCHK" & ID, chkDownload.Items.Item(ID))
            Next
        End If

        SQL.CommandText &= " ORDER BY Directory, FileName"



        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        While SQLReader.Read
            TempDownloadList.DownloadURL = SQLReader.Item("DownloadURL")
            TempDownloadList.FileName = SQLReader.Item("FileName")
            TempDownloadList.Directory = SQLReader.Item("Directory")
            downloadList.Add(TempDownloadList)
        End While

        SQLReader.Close()
        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Private Sub ResetLinkListChecked()
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime(0)
        downloadList = New ArrayList
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "UPDATE Links SET Checked = 'no'"
        SQL.ExecuteNonQuery()

        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Private Sub CheckLink(ByVal URL As String)
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime(0)
        downloadList = New ArrayList
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "UPDATE Links SET Checked = 'yes' WHERE URL = @URL"
        SQL.Parameters.AddWithValue("@URL", URL)

        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        While SQLReader.Read
            linkList.Add(SQLReader.Item("URL"))
        End While

        SQLReader.Close()
        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Private Sub SetDownloaded(ByVal DownloadURL As String)
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        Dim DateString As String = GetDateTime(0)
        downloadList = New ArrayList
        dbConn.Open()
        SQL.Connection = dbConn

        SQL.CommandText = "UPDATE Files SET Downloaded = 'yes' WHERE DownloadURL = @DownloadURL"
        SQL.Parameters.AddWithValue("@DownloadURL", DownloadURL)

        Dim SQLReader As OleDb.OleDbDataReader = SQL.ExecuteReader
        While SQLReader.Read
            linkList.Add(SQLReader.Item("DownloadURL"))
        End While

        SQLReader.Close()
        SQL.Dispose()
        dbConn.Close()
        dbConn.Dispose()
    End Sub

    Private Sub StartCrawling_Click()
        btnStartCrawl.Enabled = False
        btnDownloadFiles.Enabled = False
        btnSearchMagazine.Enabled = False
        Call AddLog("<--------------------|-------------------->" & vbNewLine & "Crawl" & vbNewLine & "<--------------------|-------------------->" & vbNewLine)
        Call ResetLinkListChecked()
        Call StartDumping()
        Call FixDirectorys()
        Call SetUpCheckBox()
        lblStatus.Text = "Crawled, Now Download"
        btnStartCrawl.Enabled = True
        btnDownloadFiles.Enabled = True
        btnSearchMagazine.Enabled = True
    End Sub

    Private Sub btnStartCrawl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartCrawl.Click
        CutData = XMLDeserialize(GetType(AllCut), "cutDataComedy.xml")
        Call StartCrawling_Click()
    End Sub
    Private Sub btnSearchMagazine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearchMagazine.Click
        CutData = XMLDeserialize(GetType(AllCut), "cutDataMagazine.xml")
        StartCrawling_Click()
    End Sub

    Private Sub btnDownloadFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDownloadFiles.Click
        btnStartCrawl.Enabled = False
        btnDownloadFiles.Enabled = False
        btnSearchMagazine.Enabled = False
        Call AddLog("<--------------------|-------------------->" & vbNewLine & "Download" & vbNewLine & "<--------------------|-------------------->" & vbNewLine)
        Call DownloadAllNewFiles()
        Call SetUpCheckBox()
        lblStatus.Text = "Downloaded"
        btnStartCrawl.Enabled = True
        btnDownloadFiles.Enabled = True
        btnSearchMagazine.Enabled = True
    End Sub

    Private Sub DrawCrawlState()
        lblStatus.Text = "Rounds: " & CurrentCrawlRound & "/" & MaxCrawlRound & vbNewLine & "Elements: " & CurrentCrawlElements & "/" & MaxCrawlElements & vbNewLine & "State: " & CrawlState
    End Sub

    Public Function LoadFile(ByVal FileName As String) As String
        Dim objStreamReader As StreamReader
        objStreamReader = New StreamReader(FileName, System.Text.Encoding.Default)
        LoadFile = objStreamReader.ReadToEnd
        objStreamReader.Close()
    End Function

    Public Sub SaveFile(ByVal FileName As String, ByVal WriteData As String)
        Dim objFileStream As FileStream
        Dim objStreamWriter As StreamWriter

        objFileStream = New FileStream(FileName, FileMode.Create, FileAccess.Write)
        objStreamWriter = New StreamWriter(objFileStream, System.Text.Encoding.Default)
        objStreamWriter.Write(WriteData)
        objStreamWriter.Close()
        objFileStream.Close()
    End Sub

    Private Sub ExportLogToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportLogToolStripMenuItem.Click
        Dim FileName As String = "Log-" & GetDateTime(0) & ".txt"
        SaveFile(AppDir & FileName, LogString)
        MsgBox("Logfile exported into the application directory" & vbNewLine & FileName, MsgBoxStyle.OkOnly, "Log")
    End Sub

    Private Sub picDonate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDonate.Click
        Process.Start("http://www.scilor.com/donate.html")
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
        Application.Exit()
    End Sub

    Private Sub CheckForUpdatesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckForUpdatesToolStripMenuItem.Click
        Dim UpdateChecker As New SciLors_UpdateCheck.SciLorsUpdateCheck()
        MsgBox(UpdateChecker.checkVersion(myProgram.name, myProgram.longname, myProgram.version), MsgBoxStyle.OkOnly, "Update Check")
    End Sub

    Private Sub SciLorsSoftwareToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SciLorsSoftwareToolStripMenuItem.Click
        Dim UpdateChecker As New SciLors_UpdateCheck.SciLorsUpdateCheck()
        MsgBox(UpdateChecker.getAll, MsgBoxStyle.OkOnly, "SciLor's Software")
    End Sub

    Private Sub VisitSciLorsWebsiteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VisitSciLorsWebsiteToolStripMenuItem.Click
        Dim ShellEx As New ProcessStartInfo()
        ShellEx.UseShellExecute = True
        ShellEx.FileName = "http://www.scilor.com"
        Process.Start(ShellEx)
    End Sub

    Private Sub ResetWebsitesLinksSpeedupToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ResetWebsitesLinksSpeedupToolStripMenuItem.Click
        Dim dbConn As OleDb.OleDbConnection = GetConnection()
        Dim SQL As New OleDb.OleDbCommand
        dbConn.Open()
        SQL.Connection = dbConn
        SQL.CommandText = "DELETE FROM Links"
        SQL.ExecuteNonQuery()
        SQL.Dispose()

        InsertURL("http://www.einslive.de/comedy/")
        MessageBox.Show("Removed all links.")
    End Sub
End Class
